/*
 * Title:        sag_internal/c_macros.hpp
 * Description:  C macros for version and win32 declspecs
 * $Copyright (c) 2015-2017 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.$
 * Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG
 * @Version:     $Id: c_macros.hpp 309496 2017-06-13 11:51:13Z mben $
 */

#ifndef _SAG_INTERNAL_C_MACROS_HPP_
#define _SAG_INTERNAL_C_MACROS_HPP_

// already in extern "C"

/**@internal ABI version bumped whenever the ABI changes */
#define SAG_PLUGIN_API_VERSION 0x00000004

/**@internal Product 4-digit version number used to publish the product version this plug-in was built against*/
#define SAG_PLUGIN_PRODUCT_VERSION "10.5.2.1"

// ensure correct importing/exporting of symbols on windows
#if defined(_WIN32) || defined(__WIN32) || defined(WIN32)
#ifdef SAG_CONNECTIVITY_BACKEND
/** Imports/exports the C free functions that are exported by apclient. 
@private
*/
#define SAG_CONNECTIVITY_API __declspec(dllexport)
#define SAG_CONNECTIVITY_DLL_SYM __declspec(dllimport)
#else
/** Imports/exports the C free functions that are exported by apclient. 
@private
*/
#define SAG_CONNECTIVITY_API __declspec(dllimport)
#define SAG_CONNECTIVITY_DLL_SYM __declspec(dllexport)
#endif
#define SAG_CONNECTIVITY_CALL __stdcall
#else
/** Imports/exports the C free functions that are exported by apclient.
@private
*/
#define SAG_CONNECTIVITY_API
#define SAG_CONNECTIVITY_CALL
#define SAG_CONNECTIVITY_DLL_SYM 
#endif


#endif // _SAG_INTERNAL_C_MACROS_HPP_
