// $Copyright(c) 2009, 2012 Progress Software Corporation (PSC). All rights reserved.\$
// $Copyright (c) 2013, 2015, 2017 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.\$
// Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG
function addprofilehandler(req, nodes, containernode, formatter) {
	req.onreadystatechange=function handler() {
		if (req.readyState == 4) {
			if (200 == req.status) {
				datacallback(req.responseXML, req.statusText, nodes, containernode, formatter);
			} else {
				alert("Request failed: "+req.statusText);
			}
		}
	}
}

function addCommas(nStr)
{
	nStr += '';
	x = nStr.split('.');
	x1 = x[0];
	x2 = x.length > 1 ? '.' + x[1] : '';
	var rgx = /(\d+)(\d{3})/;
	while (rgx.test(x1)) {
		x1 = x1.replace(rgx, '$1' + ',' + '$2');
	}
	return x1 + x2;
}

function formatprofile(columndata, profdata) {
	for (i = 0; i < profdata.length-1; ++i) {
		columndata[i] = { "sTitle": profdata[i] }
	}
	for (i = 4; i < profdata.length-1; ++i) {
		columndata[i]["fnRender"] = function(oObj) {
			if ("" == oObj.aData[oObj.iDataColumn]) return "";
			return addCommas(oObj.aData[oObj.iDataColumn]);
		}
	}
	columndata[3]["fnRender"] = function(oObj) {
						if ("" == oObj.aData[3]) return "";
						data = oObj.aData[3].split(":");
						filename = escape(data[0].replace("/\\./gi", "$"));
						line = data[1];
						return "<a href='#' onclick='gotoFile(\""+filename+"\", \""+line+"\");'>"+oObj.aData[3]+"</a>";
					};
}

function formatmemory(columndata, profdata) {
	for (i = 0; i < profdata.length; ++i) {
		columndata[i] = { "sTitle": profdata[i] }
	}
	for (i = 3; i < profdata.length; ++i) {
		columndata[i]["fnRender"] = function(oObj) {
			if ("" == oObj.aData[oObj.iDataColumn]) return "";
			return addCommas(oObj.aData[oObj.iDataColumn]);
		}
	}
}

function pad_arrays(num, value, arrays) {
	rv = [];
	for (i = 0; i < arrays.length; ++i) {
		if (arrays[i].length < num) {
			for (j = arrays[i].length-1; j < num; ++j) {
				arrays[i][j] = value;
			}
		} else if (arrays[i].length > num) {
			arrays[i] = arrays[i].slice(0, num);
		}
	}
	return arrays;
}

function get_slice(data, num)
{
	start = 0;
	end = data.length;
	columncount = data[0].length;
	count = 0;
	for (g_s_i = 1; g_s_i < data.length; ++g_s_i) {
		if (columncount != data[g_s_i].length) {
			count = count + 1;
			columncount = data[g_s_i].length;
			if (count == num) { start = g_s_i; }
			if (count == num+1) { end = g_s_i+1; break; }
		}
	}
	return data.slice(start, end);
}

function datacallback(data, textStatus, nodes, containernode, formatter)
{
	csvdata = data.getElementsByTagName("map")[0].firstChild.firstChild.nodeValue;
	profdata = $.csv(',', '"', "\n")(csvdata);
	for (d_c_i = 0; d_c_i < nodes.length; ++d_c_i) {
		if (nodes.length > 1) {
			pdata = get_slice(profdata, d_c_i);
		} else {
			pdata = profdata;
		}
		node = nodes[d_c_i];
		columndata = [];
		formatter(columndata, pdata[0]);
		pdata = pad_arrays(columndata.length, "", pdata.slice(1,pdata.length-1))
		if ($("#"+node+"_wrapper").length > 0) {
			$("#"+node+"_wrapper").remove();
			$("#"+containernode+"_div").append("<table id='"+node+"' class='tableApamaResponse' />");
		}
		$('#'+node).dataTable({
				"aaData": pdata,
				"aoColumns": columndata,
				});
	}
}
function gotoFile(filename, lineno) {
	var req = initXHR();
	req.onreadystatechange=function handler() {
		if (req.readyState == 4) {
			if (200 == req.status) {
				hash = $(req.responseXML).find("prop[name='filehash']").text();
				window.location.href = "/correlator/code/hash/"+hash+"/"+lineno;
			}
		}
	}
	req.open('PUT', "/correlator/code/map");
	req.send('<map name="apama-request"><prop name="filename">'+filename+'</prop></map>');
}
function loadprofile() {
	var req = initXHR();
	addprofilehandler(req, ["profilingdata"], "profilingdata", formatprofile);
	req.open('PUT', "/request");
	req.send('<map name="apama-request"><list name="request"><prop name="type">cpuProfile</prop><prop name="arg">get</prop></list></map>');
} 

function loadmemory() {
	var req = initXHR();
	addprofilehandler(req, ["memorydata1","memorydata2"], "memorydata", formatmemory);
	req.open('PUT', "/request");
	req.send('<map name="apama-request"><list name="request"><prop name="type">memoryStatsMThreads</prop></list></map>');
} 

